package edu.nyu.scps.zipcode;

import java.io.BufferedInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.widget.Toast;

public class Helper extends SQLiteOpenHelper {
	private static String FILENAME =
		"/data/data/edu.nyu.scps.zipcode/databases/zipcode.sqlite";
	private Context context;

	public Helper(Context context) {
		super(context, FILENAME, null, 1);
		this.context = context;
	}

	@Override
	public void onCreate(SQLiteDatabase db) {
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
	}
	     
	public Cursor getCursor() {
		//Must create the file before onCreate is called.

		try {
			URL url = new URL("http://i5.nyu.edu/~mm64/INFO1-CE9705/src/zipcode2/zipcode.sqlite");
			URLConnection connection = url.openConnection();
			InputStream inputStream = new BufferedInputStream(connection.getInputStream());
			OutputStream outputStream = new FileOutputStream(FILENAME);
			byte[] buffer = new byte[1024];
			int length;
        	
			//Copy the inputfile to the outputfile.
			while ((length = inputStream.read(buffer)) > 0) {
				outputStream.write(buffer, 0, length);
			}

			inputStream.close();
			outputStream.close();
		} catch (MalformedURLException exception) {
			Toast.makeText(context, "malformed URL: " + exception, Toast.LENGTH_LONG).show();
		} catch (IOException exception) {
			Toast.makeText(context, "IO exception: " + exception, Toast.LENGTH_LONG).show();
		}

		SQLiteDatabase database = getReadableDatabase();	//call onCreate

		//Prepend zeroes to zipcode to make it a five-digit number.
		String select = "SELECT _id, substr('00000' || zipcode, -5, 5) AS zipcode, "
			+ "city, state, latitude, longitude, county FROM zipcodes;";

		Cursor cursor = database.rawQuery(select, null);
		cursor.moveToFirst();
		return cursor;
	}
}
