package edu.nyu.scps.zipcode;

import android.app.ListActivity;
import android.database.Cursor;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.LinearLayout;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;
import android.widget.Toast;

public class ZipcodeActivity extends ListActivity {

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		String[] fields = new String[] {
			"zipcode",
			"city",
			"state",
			"latitude",
			"longitude",
			//"county"
		};

		int[] textViews = new int[] {
			R.id.zipcode,
			R.id.city,
			R.id.state,
			R.id.latitude,
			R.id.longitude,
			//R.id.county
		};

		ListAdapter adapter = new SimpleCursorAdapter(
			this,
			R.layout.list_item,
			new Helper(this).getCursor(),
			fields,
			textViews
		);
				
		setListAdapter(adapter);
		ListView listView = getListView();
		listView.setTextFilterEnabled(true);	//Type characters to select an item.

		listView.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				TextView city = (TextView)((LinearLayout)view).getChildAt(1);
				String s = position + " " + id + " " + city.getText();
				Toast.makeText(ZipcodeActivity.this, s, Toast.LENGTH_LONG).show();  
			}
		});
	}
}